/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export class BaseClass {
    baseClassProperty: string;
}

export class DerivedClass extends BaseClass {
    derivedClassProperty: string;
}

export interface IBaseInterface {
    baseInterfaceProperty: string;
}

export interface IDerivedInterface extends IBaseInterface {
    derivedInterfaceProperty: string;
}

export type UnionType = IDerivedInterface | DerivedClass;

export type IntersectionType = IDerivedInterface & DerivedClass;

export class TestController {
    constructor(private fetcher: IFetcher) { }
    postClass = (query?: DerivedClass, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/class${this.fetcher.buildQueryString(query)}`, "post", "application/json", undefined, headers);
    };
    getClass = (query?: DerivedClass, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/class${this.fetcher.buildQueryString(query)}`, "get", "application/json", undefined, headers);
    };
    postInterface = (query?: IDerivedInterface, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/interface${this.fetcher.buildQueryString(query)}`, "post", "application/json", undefined, headers);
    };
    getInterface = (query?: IDerivedInterface, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/interface${this.fetcher.buildQueryString(query)}`, "get", "application/json", undefined, headers);
    };
    postUnion = (query?: UnionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/union${this.fetcher.buildQueryString(query)}`, "post", "application/json", undefined, headers);
    };
    getUnion = (query?: UnionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/union${this.fetcher.buildQueryString(query)}`, "get", "application/json", undefined, headers);
    };
    postIntersection = (query?: IntersectionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/intersection${this.fetcher.buildQueryString(query)}`, "post", "application/json", undefined, headers);
    };
    getIntersection = (query?: IntersectionType, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/intersection${this.fetcher.buildQueryString(query)}`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    test = new TestController(this.fetcher);
}